﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApp65
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // It turned this off, because the borderless headers on Windows 10 looks kinda weird
            // with this layout.
            this.ultraGrid1.UseOsThemes = Infragistics.Win.DefaultableBoolean.False;

            for (int i = 0; i < 20; i++)
            {
                this.ultraDataSource1.Rows.Add();
            }
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];

            layout.AutoFitStyle = AutoFitStyle.ExtendLastColumn;

            band.RowLayoutStyle = Infragistics.Win.UltraWinGrid.RowLayoutStyle.ColumnLayout;
            band.RowLayoutLabelStyle = Infragistics.Win.UltraWinGrid.RowLayoutLabelStyle.WithCellData;

            // We could set this on each column. But since most of the columns will have their 
            // label on the left,  we can set this as the default for the band and just override
            // it on the Note column.
            band.RowLayoutLabelPosition = Infragistics.Win.UltraWinGrid.LabelPosition.Left;

            var noteDateColumn = band.Columns["NoteDate"];
            var providerColumn = band.Columns["Provider"];
            var userColumn = band.Columns["User"];
            var userNameColumn = band.Columns["UserName"];
            var programColumn = band.Columns["Program"];
            var noteColumn = band.Columns["Note"];

            this.SetRowLayoutColumnInfo(noteDateColumn, 0);
            this.SetRowLayoutColumnInfo(providerColumn, 1);
            this.SetRowLayoutColumnInfo(userColumn, 2);
            this.SetRowLayoutColumnInfo(userNameColumn, 3);
            this.SetRowLayoutColumnInfo(programColumn, 4);

            noteColumn.RowLayoutColumnInfo.LabelPosition = LabelPosition.Top;
            noteColumn.RowLayoutColumnInfo.OriginX = 2; // Since the span of the other columns is 2, we use 2 here to put this to the right of them.
            noteColumn.RowLayoutColumnInfo.OriginY = 0;
            noteColumn.RowLayoutColumnInfo.SpanX = 1;
            noteColumn.RowLayoutColumnInfo.SpanY = 5; // This is the total of the other 5 columns. 

            
        }

        private void SetRowLayoutColumnInfo(UltraGridColumn column, int originY)
        {
            column.RowLayoutColumnInfo.OriginX = 0;
            column.RowLayoutColumnInfo.OriginY = originY;
            column.RowLayoutColumnInfo.SpanX = 2; // We need 2 here for the Label + Cell.
            column.RowLayoutColumnInfo.SpanY = 1;
        }
    }
}
